<template>
  <div class="container-search">
    <b-input-group size="sm" class="mb-2">
      <b-input-group-prepend is-text>
        <b-icon icon="search"></b-icon>
      </b-input-group-prepend>
      <b-form-input
        type="search"
        placeholder="Search"
        v-model="form.name"
        @keyup.enter="searchName(form)"
      ></b-form-input>
      <b-dropdown text="SORT" variant="info" size="sm">
        <div v-for="item in filter" :key="item">
          <b-dropdown-item @click="changeFilter(item)">{{
            item
          }}</b-dropdown-item>
        </div>
      </b-dropdown>
    </b-input-group>
    <div class="container-table">
      <b-table
        sticky-header
        :items="filteredData"
        head-variant="light"
      ></b-table>
    </div>
  </div>
</template>

<script>
export default {
  props: {
    tableData: []
  },
  created() {
    this.setFilter()
  },
  data() {
    return {
      form: {
        name: ''
      },
      gradeFilter: ['All', 'A', 'B+', 'B'],
      typeFilter: ['All', 'SBR', 'ST'],
      returnFilter: ['All', 'Positive (>=0)', 'Negative (<0)'],
      filter: [],
      filteredData: this.tableData,
      type: ''
    }
  },
  methods: {
    searchName() {
      let findData = this.tableData
      if (this.form.name) {
        findData = findData.filter(
          (item) => item.name.indexOf(this.form.name.toUpperCase()) >= 0
        )
      }

      this.filteredData = [...findData]
    },
    setFilter() {
      if (this.tableData[0].grade) {
        this.filter = this.gradeFilter
        this.type = 'grade'
      } else if (this.tableData[0].type) {
        this.filter = this.typeFilter
        this.type = 'type'
      } else if (this.tableData[0].return) {
        this.filter = this.returnFilter
        this.type = 'return'
      } else {
        this.filter = []
      }
    },
    changeFilter(value) {
      let filtered = this.tableData
      if (this.form.name) {
        if (value !== 'All') {
          if (this.type === 'return') {
            if (value === 'Positive (>=0)') {
              filtered = this.tableData.filter(
                (item) =>
                  item.return >= 0 &&
                  item.name.indexOf(this.form.name.toUpperCase()) >= 0
              )
            } else if (value === 'Negative (<0)') {
              filtered = this.tableData.filter(
                (item) =>
                  item.return < 0 &&
                  item.name.indexOf(this.form.name.toUpperCase()) >= 0
              )
            }
          } else if (this.type === 'grade') {
            if (value === 'A') {
              filtered = this.tableData.filter(
                (item) =>
                  item.grade === 'A' &&
                  item.name.indexOf(this.form.name.toUpperCase()) >= 0
              )
            } else if (value === 'B+') {
              filtered = this.tableData.filter(
                (item) =>
                  item.grade === 'B+' &&
                  item.name.indexOf(this.form.name.toUpperCase()) >= 0
              )
            } else if (value === 'B') {
              filtered = this.tableData.filter(
                (item) =>
                  item.grade === 'B' &&
                  item.name.indexOf(this.form.name.toUpperCase()) >= 0
              )
            }
          } else if (this.type === 'type') {
            if (value === 'SBR') {
              filtered = this.tableData.filter(
                (item) =>
                  item.type === 'SBR' &&
                  item.name.indexOf(this.form.name.toUpperCase()) >= 0
              )
            } else if (value === 'ST') {
              filtered = this.tableData.filter(
                (item) =>
                  item.type === 'ST' &&
                  item.name.indexOf(this.form.name.toUpperCase()) >= 0
              )
            }
          }
        }
      } else {
        if (value !== 'All') {
          if (this.type === 'return') {
            if (value === 'Positive (>=0)') {
              filtered = this.tableData.filter((item) => item.return >= 0)
            } else if (value === 'Negative (<0)') {
              filtered = this.tableData.filter((item) => item.return < 0)
            }
          } else if (this.type === 'grade') {
            if (value === 'A') {
              filtered = this.tableData.filter((item) => item.grade === 'A')
            } else if (value === 'B+') {
              filtered = this.tableData.filter((item) => item.grade === 'B+')
            } else if (value === 'B') {
              filtered = this.tableData.filter((item) => item.grade === 'B')
            }
          } else if (this.type === 'type') {
            if (value === 'SBR') {
              filtered = this.tableData.filter((item) => item.type === 'SBR')
            } else if (value === 'ST') {
              filtered = this.tableData.filter((item) => item.type === 'ST')
            }
          }
        }
      }

      this.filteredData = [...filtered]
    }
  }
}
</script>

<style scoped>
.container-search {
  margin-top: 20px;
}

.container-table {
  font-size: 12px;
}

.search-icon {
  width: 40px;
}

.show > .btn-info.dropdown-toggle {
  color: #fff;
  background-color: grey !important;
  border-color: grey !important;
}

.btn-info {
  color: #fff;
  background-color: grey !important;
  border-color: grey !important;
}

.b-table-sticky-header {
  overflow-y: auto;
  max-height: 250px;
}
</style>
